﻿''' <summary>
''' Compare 2 IObject items.
''' </summary>
''' <remarks>Because Icomparer can not work with 3 objects I
''' needed to include the own comparation</remarks>
Public Class clsSorter
    Implements IComparer


    Public Function ITbCompare(ByVal O1 As IObject, ByVal O2 As IObject) As Integer
        If O1 Is O2 Then Return 0
        If TypeOf O1 Is clsStart Then Return -1
        If TypeOf O1 Is clsEnd Then Return 1
        If TypeOf O2 Is clsStart Then Return 1
        If TypeOf O2 Is clsEnd Then Return -1


        If O2.GetType = O1.NeededNextObject Then Return 0 '-1 ' there is still something to do
        If O1.GetType = O2.NeededNextObject Then Return 0 ' 1

        If O1.Index < O2.Index Then
            Return -1
        ElseIf O2.Index < O1.Index Then
            Return 1
        Else
            Return 0
        End If



        Return String.Compare(O1.Title, O2.Title)
    End Function


    ''' <summary>
    ''' Compare 2 IObject objects
    ''' </summary>
    ''' <param name="o1">IObject </param>
    ''' <param name="o2">IObject</param>
    Public Function Compare(ByVal o1 As Object, ByVal o2 As Object) As Integer Implements IComparer.Compare
        Return ITbCompare(CType(o1, IObject), CType(o2, IObject))

    End Function


#Region "Distance"
    ''' <summary>
    ''' Calculate the distance between 2 points
    ''' </summary>
    Public Function GetDistance(ByVal O1 As IObject, ByVal O2 As IObject) As Single
        Return GetDistance(O1.Location, O2.Location)
    End Function

    Private Function GetDistance(ByVal Loc1 As Point, ByVal Loc2 As Point) As Single
        Return GetDistance(Loc1.X, Loc1.Y, Loc2.X, Loc2.Y)
    End Function

    Private Function GetDistance(ByVal X1 As Double, ByVal Y1 As Double, ByVal X2 As Double, ByVal Y2 As Double) As Double
        Dim theta As Double = X1 - X2
        'Dim dist As Double = Math.Sin(deg2rad(Y1)) * Math.Sin(deg2rad(Y2)) + Math.Cos(deg2rad(Y1)) * Math.Cos(deg2rad(Y2)) * Math.Cos(deg2rad(theta))
        'dist = Math.Acos(dist)
        'dist = rad2deg(dist)
        Dim dist As Double = Math.Sqrt((X1 - X2) ^ 2 + (Y1 - Y2) ^ 2)
        Return dist
    End Function

    Private Function deg2rad(ByVal deg As Double) As Double
        Return (deg * Math.PI / 180.0)
    End Function

    Private Function rad2deg(ByVal rad As Double) As Double
        Return rad / Math.PI * 180.0
    End Function
#End Region

End Class
