﻿''' <summary>
''' status bar
''' </summary>
''' <remarks>not really in use at this state</remarks>
Public Class ucStateBar
    Private WithEvents TimerTime As System.Windows.Threading.DispatcherTimer


#Region "Time"

    ''' <summary>
    ''' Time Dependency Property
    ''' </summary>
    Public Shared ReadOnly TimeProperty As DependencyProperty = _
        DependencyProperty.Register("Time", GetType(DateTime), GetType(ucStateBar), _
            New FrameworkPropertyMetadata(DateTime.MinValue))

    ''' <summary>
    ''' Gets or sets the Time property.  This dependency property 
    ''' indicates what time it is
    ''' </summary>
    Public Property Time() As DateTime
        Get
            Return CType(GetValue(TimeProperty), DateTime)
        End Get
        Set(ByVal value As DateTime)
            SetValue(TimeProperty, value)
        End Set
    End Property

#End Region



#Region "State"

    ''' <summary>
    ''' State Dependency Property
    ''' </summary>
    Public Shared ReadOnly StateProperty As DependencyProperty = _
        DependencyProperty.Register("State", GetType(String), GetType(ucStateBar), _
            New FrameworkPropertyMetadata(""))

    ''' <summary>
    ''' Gets or sets the State property.  This dependency property 
    ''' indicates the state
    ''' </summary>
    Public Property State() As String
        Get
            Return CType(GetValue(StateProperty), String)
        End Get
        Set(ByVal value As String)
            SetValue(StateProperty, value)
        End Set
    End Property

#End Region


#Region "ProgressPercent"

    ''' <summary>
    ''' ProgressPercent Dependency Property
    ''' </summary>
    Public Shared ReadOnly ProgressPercentProperty As DependencyProperty = _
        DependencyProperty.Register("ProgressPercent", GetType(Single), GetType(ucStateBar), _
            New FrameworkPropertyMetadata(CSng(0), _
                AddressOf OnProgressPercentChanged))

    ''' <summary>
    ''' Gets or sets the ProgressPercent property.  This dependency property 
    ''' indicates ....
    ''' </summary>
    Public Property ProgressPercent() As Single
        Get
            Return CType(GetValue(ProgressPercentProperty), Single)
        End Get
        Set(ByVal value As Single)
            SetValue(ProgressPercentProperty, value)
        End Set
    End Property

    ''' <summary>
    ''' Handles changes to the ProgressPercent property.
    ''' </summary>
    Private Overloads Shared Sub OnProgressPercentChanged(ByVal d As DependencyObject, ByVal e As DependencyPropertyChangedEventArgs)
        Dim target As ucStateBar = CType(d, ucStateBar)
        Dim oldProgressPercent As Single = CType(e.OldValue, Single)
        Dim newProgressPercent As Single = target.ProgressPercent
        target.OnProgressPercentChanged(oldProgressPercent, newProgressPercent)
    End Sub

    ''' <summary>
    ''' Provides derived classes an opportunity to handle changes to the ProgressPercent property.
    ''' </summary>
    Protected Overridable Overloads Sub OnProgressPercentChanged(ByVal oldProgressPercent As Single, ByVal newProgressPercent As Single)
        Me.txtProgress.Text = "Progress: " & newProgressPercent.ToString("0.0") & "%"
    End Sub

#End Region






    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        TimerTime = New System.Windows.Threading.DispatcherTimer
        TimerTime.Interval = TimeSpan.FromSeconds(1)
        TimerTime.Start()

        Me.DataContext = Me
    End Sub


    Private Sub TimerTime_Tick(sender As Object, e As System.EventArgs) Handles TimerTime.Tick
        Me.Time = Now
    End Sub
End Class
